@echo off
SETLOCAL
SETLOCAL EnableDelayedExpansion

set result=0
set errorlevel=0
set DOMY=%~dp0
set BASE=domy-ce
set cfgm=%DOMY%%BASE%
if not exist "%cfgm%" (
	echo Error: Please verify installation.
	echo %cfgm% not found.
	exit /b 1
	)
if exist "%USERPROFILE%\domy\%BASE%.ini" (set userfiles=%USERPROFILE%\domy)
if exist "%USERPROFILE%\domt\%BASE%.ini" (set userfiles=%USERPROFILE%\domt)

set graphs=%userfiles%\graphs-ce
set plugins=%userfiles%\plugins
set rootfolder=%HOMEDRIVE%\domy

set graphsexist=0
set deletegraphs=0
set pluginsexist=0
set deleteplugins=0
if exist "%graphs%" set graphsexist=1
if exist "%plugins%" set pluginsexist=1
if not "%1" == "-c" python "%cfgm%" -vS
if errorlevel 1 (
	echo %~n0 - configuration failure - reinstallation required
	exit /b 1
	)
if exist "%graphs%" (
	if %graphsexist%==0 set deletegraphs=1
) else (
	set graphs=%DOMY%graphs-ce
	)
if exist "%plugins%" (
	if %pluginsexist%==0 set deleteplugins=1
) else (
	set plugins=%DOMY%plugins
	)

:: set rootfolder - indirect method to compensate for variable expansion
for %%F in ("%DOMY:~0,-1%") do set rootfolder2=%%~dpF
for %%F in ("%rootfolder2:~0,-1%") do set rootfolder2=%%~dpFshare\domy
for %%F in ("%DOMY:~0,-1%") do set rootfolder3=%%~dpF
for %%F in ("%rootfolder3:~0,-1%") do set rootfolder3=%%~dpFshare\corpusfg
if not exist "%rootfolder%" (
	if exist "%rootfolder2%" (
		set rootfolder=%rootfolder2%
	) else (
		set rootfolder=%rootfolder3%
		)
	)
:: echo DOMY          %DOMY%
:: echo cfgm          %cfgm%
:: echo graphs        %graphs%
:: echo plugins       %plugins%
:: echo rootfolder    %rootfolder%
:: echo deletegraphs  %deletegraphs%
:: echo deleteplugins %deleteplugins%
:: call :leave
:: goto :EOF

:start
cls
















echo Introduction:
echo.
echo This second demo runs example "GRAPHS" 6 to 14 to consolidate data,
echo train translation models, evaluate translation models and translate
echo documents using both translation models.
echo.
echo Example 6 cleans a micro corpus for use as SMT training corpus
echo Example 7 creates the lm BUILD set named "micro_lm"
echo Example 8 creates the tm BUILD set named "micro_tm"
echo Example 9 trains, tunes, evaluates a "micro" translation model [Linux only]
echo Example 10 cleans a demo corpus from same data with different options
echo Example 11 creates the lm BUILD set named "demo_lm"
echo Example 12 creates the tm BUILD set named "demo_tm"
echo Example 13 trains, tunes, evaluates a "demo" translation model [Linux only]
echo Example 14 translates sample document with both models [Linux only]
echo.
echo You can find the GRAPHs and their config.ini files in:
echo %graphs%
echo.

echo Next: Instructions
if not "%1" == "-c" pause
cls

echo Instructions:
echo.
echo This is a wizard-style demo. It pauses before running an example
echo with a short description and the GRAPH's command line.
echo.
echo It pauses after running the example to show the command line,
echo the input and output of the example.
echo.
echo.

echo Next: Example 6, prepare nl-en sample data [micro set]
if not "%1" == "-c" pause
cls

echo Example 6: prepare nl-en sample data [micro set]
echo.
echo This GRAPH prepares sentence-aligned [sa] text files for use as SMT
echo training corpus. Files in "tm" trees are processed as pairs. This
echo GRAPH's config.ini file defines:
echo      mintoken = 3
echo      maxtoken = 20
echo      ratio = 4:1
echo.
echo Command:  "%~d0> %BASE% clean-tm"
echo.
if not "%1" == "-c" pause
cls




echo Example 6: prepare nl-en sample data [micro set]
echo.
echo Command:  "%~d0> %BASE% clean-tm"
echo.
if exist "%graphs%\clean-tm\Demonstrate cleaning parallel micro nl-en corpus.conf" (
	copy /y "%graphs%\clean-tm\config.ini" "%graphs%\clean-tm\.config.ini.tmp" > nul
	copy /y "%graphs%\clean-tm\Demonstrate cleaning parallel micro nl-en corpus.conf" "%graphs%\clean-tm\config.ini" > nul
	python "%cfgm%" -v clean-tm
	if errorlevel 1 (
		set result=1
	) else (
		echo.
		echo Review
		echo Command:  "%~d0> %BASE% clean-tm"
		echo Inputs:   "file://%rootfolder%\CORPORA\sa\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Outputs1: "file://%rootfolder%\CORPORA.demo\ready_micro\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Outputs2: "file://%rootfolder%\CORPORA.demo\ready_micro-workbench\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo.
		)
	copy /y "%graphs%\clean-tm\.config.ini.tmp" "%graphs%\clean-tm\config.ini" > nul
	del /q "%graphs%\clean-tm\.config.ini.tmp"
) else (
	echo "clean-tm" micro configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 7, create an lm BUILD set named "micro_lm"
if not "%1" == "-c" pause
cls

echo Example 7: create an lm BUILD set named "micro_lm"
echo.
echo Training a translation model requires a language model "BUILD" set
echo created. here, and a tm "BUILD" set created in Examples 10 and 11 below.
echo This GRAPH selects and consolidates target language data to create both
echo a language model and to train a "recaser" model.
echo.
echo Command:  "%~d0> %BASE% build-lm"
echo.
if not "%1" == "-c" pause
cls

echo Example 7: create an lm BUILD set named "micro_lm"
echo.
echo Command:  "%~d0> %BASE% build-lm"
echo.
if exist "%graphs%\build-lm\Demonstrate building lm build set with micro nl-en corpus.conf" (
	copy /y "%graphs%\build-lm\config.ini" "%graphs%\build-lm\.config.ini.tmp" > nul
	copy /y "%graphs%\build-lm\Demonstrate building lm build set with micro nl-en corpus.conf" "%graphs%\build-lm\config.ini" > nul
	python "%cfgm%" -v build-lm
	if errorlevel 1 (
		set result=1
	) else (
		echo.
		echo Review
		echo Command:  "%~d0> %BASE% build-lm"
		echo Inputs1:  "file://%rootfolder%\CORPORA.demo\ready_demo\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Inputs2:  "file://%rootfolder%\CORPORA.demo\ready_demo-workbench\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Inputs3:  "file://%rootfolder%\CORPORA.demo\ready_demo-workbench\EuroParl%20v5\Legislation\debates\lm\nl\"
		echo Output:   "file://%rootfolder%\BUILDS\lm\micro_lm\"
		echo.
		)
	copy /y "%graphs%\build-lm\.config.ini.tmp" "%graphs%\build-lm\config.ini" > nul
	del /q "%graphs%\build-lm\.config.ini.tmp"
) else (
	echo "build-lm" micro configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 8, create a tm BUILD set named "micro_tm"
if not "%1" == "-c" pause
cls

echo Example 8: create a tm BUILD set named "micro_tm"
echo.
echo The example GRAPHS in demo-1.sh processed all data in their original,
echo separate files. This allows users to maintain data categories during
echo processing. The separate data files must be consolidated before
echo training. The "BUILD" process selects, consolidates the data. This
echo GRAPH creates a tm "BUILD" set with 12 files from the "micro"
echo SMT data set created in demo-1.sh. This GRAPH's config file defines:
echo      mertset = 300
echo      evalset = 300
echo.
echo Command:  "%~d0> %BASE% build-tm"
echo.
if not "%1" == "-c" pause
cls

echo Example 8: create a tm BUILD set named "micro_tm"
echo.
echo Command:  "%~d0> %BASE% build-tm"
echo.
if exist "%graphs%\build-tm\Demonstrate building tm build set with micro nl-en corpus.conf" (
	copy /y "%graphs%\build-tm\config.ini" "%graphs%\build-tm\.config.ini.tmp" > nul
	copy /y "%graphs%\build-tm\Demonstrate building tm build set with micro nl-en corpus.conf" "%graphs%\build-tm\config.ini" > nul
	python "%cfgm%" -v build-tm
	if errorlevel 1 (
		set result=1
	) else (
		echo.
		echo Review
		echo Command:  "%~d0> %BASE% build-tm"
		echo Inputs:   "file://%rootfolder%\CORPORA.demo\ready_demo\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Outputs:  "file://%rootfolder%\BUILDS\tm\micro_tm"
		echo.

		)
	copy /y "%graphs%\build-tm\.config.ini.tmp" "%graphs%\build-tm\config.ini" > nul
	del /q "%graphs%\build-tm\.config.ini.tmp"
) else (
	echo "build-tm" micro configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 9, train a translation model with BUILD sets named "micro_tm" and "micro_lm"
if not "%1" == "-c" pause
cls

echo Example 9: train a translation model with BUILD sets named
echo             "micro_tm" and "micro_lm"
echo.
echo The training process consists of five sub-steps:
echo    1. train-lm      - trains the language model
echo    2. train-tm      - trains the phrase and reordering tables, then
echo                       binarizes the tables This takes a long time.
echo    3. train-mert    - "Minimum Error Rate Tuning" creates a translation
echo                       model consisting of phrase and reordering tables,
echo                       a language model and confiuration file with
echo                       optimal settings. This takes a long time.
echo    4. train-eval    - evaluates the "tuned" translation model
echo    5. train-recaser - trains a recaser model that restores
echo                       upper\lower case to translations
echo.
echo Command:  "%~d0> %BASE% train"
echo.
if not "%1" == "-c" pause
cls




echo Example 9: train a translation model with BUILD sets named
echo             "micro_tm" and "micro_lm"
echo.
echo Command:  "%~d0> %BASE% train"
echo.
if exist "%graphs%\train\Demonstrate complete training and tuning with micro nl-en corpus.conf" (
	echo Can not run Example 9 on MS Windows
	echo.
rem 	if not "%1" == "-s" (
rem 		copy /y "%graphs%\train\config.ini" "%graphs%\train\.config.ini.tmp" > nul
rem 		copy /y "%graphs%\train\Demonstrate complete training and tuning with micro nl-en corpus.conf" "%graphs%\train\config.ini" > nul
rem 		python "%cfgm%" -v train
rem 		if errorlevel 1 (
rem 			set result=1
rem 		) else (
rem 			echo.
rem 			echo Review
rem 			echo Command: "%~d0> %BASE% train"
rem 			echo Input1:  "file://%rootfolder%\BUILDS\lm\micro_lm"
rem 			echo Input2:  "file://%rootfolder%\BUILDS\tm\micro_tm"
rem 			echo Output:  "file://%rootfolder%\ENGINES\evals\eval-s=nl-t=en-p=micro_tm-a=giza-g=3-l=micro_lm-T=irstlm-n=3\moses-mert.mteval-v12.pl.txt"
rem 			echo.
rem 			)
rem 		copy /y "%graphs%\train\.config.ini.tmp" "%graphs%\train\config.ini" > nul
rem 		del /q "%graphs%\train\.config.ini.tmp"
rem			)
) else (
	echo "train" micro configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 10, prepare nl-en sample data [demo set]
if not "%1" == "-c" pause
cls

echo Example 10: prepare nl-en sample data [demo set]
echo.
echo This GRAPH starts with the same data as Example 6. New "mintoken",
echo and "maxtoken" settings create a larger SMT training data set. This
echo GRAPH's config file defines:
echo      mintoken = 2
echo      maxtoken = 65
echo      ratio = 4:1
echo.
echo Command:  "%~d0> %BASE% clean-tm"
echo.
if not "%1" == "-c" pause
cls




echo Example 10: prepare nl-en sample data [demo set]
echo.
echo Command:  "%~d0> %BASE% clean-tm"
echo.
if exist "%graphs%\clean-tm\Demonstrate cleaning parallel demo nl-en corpus.conf" (
	copy /y "%graphs%\clean-tm\config.ini" "%graphs%\clean-tm\.config.ini.tmp" > nul
	copy /y "%graphs%\clean-tm\Demonstrate cleaning parallel demo nl-en corpus.conf" "%graphs%\clean-tm\config.ini" > nul
	python "%cfgm%" -v clean-tm
	if errorlevel 1 (
		set result=1
	) else (
		echo.
		echo Review
		echo Command:  "%~d0> %BASE% clean-tm"
		echo Inputs:   "file://%rootfolder%\CORPORA\sa\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Outputs1: "file://%rootfolder%\CORPORA.demo\ready_demo\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Outputs2: "file://%rootfolder%\CORPORA.demo\ready_demo-workbench\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo.
		)
	copy /y "%graphs%\clean-tm\.config.ini.tmp" "%graphs%\clean-tm\config.ini" > nul
	del /q "%graphs%\clean-tm\.config.ini.tmp"
) else (
	echo "clean-tm" demo configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 11, create an lm BUILD set named "demo_lm"
if not "%1" == "-c" pause
cls

echo Example 11: create an lm BUILD set named "demo_lm"
echo.
echo Training a translation model requires a language model "BUILD" set
echo created. here, and a tm "BUILD" set created in Examples 10 and 11 below.
echo This GRAPH selects and consolidates target language data to create both
echo a language model and to train a "recaser" model.
echo.
echo Command:  "%~d0> %BASE% build-lm"
echo.
if not "%1" == "-c" pause
cls


echo Example 11: create an lm BUILD set named "demo_lm"
echo.
echo Command:  "%~d0> %BASE% build-lm"
echo.
if exist "%graphs%\build-lm\Demonstrate building lm build set with demo nl-en corpus.conf" (
	copy /y "%graphs%\build-lm\config.ini" "%graphs%\build-lm\.config.ini.tmp" > nul
	copy /y "%graphs%\build-lm\Demonstrate building lm build set with demo nl-en corpus.conf" "%graphs%\build-lm\config.ini" > nul
	python "%cfgm%" -v build-lm
	if errorlevel 1 (
		set result=1
	) else (
		echo.
		echo Review
		echo Command:  "%~d0> %BASE% build-lm"
		echo Inputs1:  "file://%rootfolder%\CORPORA.demo\ready_demo\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Inputs2:  "file://%rootfolder%\CORPORA.demo\ready_demo-workbench\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Inputs3:  "file://%rootfolder%\CORPORA.demo\ready_demo-workbench\EuroParl%20v5\Legislation\debates\lm\nl\"
		echo Output:   "file://%rootfolder%\BUILDS\lm\demo_lm\"
		echo.



		)
	copy /y "%graphs%\build-lm\.config.ini.tmp" "%graphs%\build-lm\config.ini" > nul
	del /q "%graphs%\build-lm\.config.ini.tmp"
) else (
	echo "build-lm" demo configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 12, create a tm BUILD set named "demo_tm"
if not "%1" == "-c" pause
cls

echo Example 12: create a tm BUILD set named "demo_tm"
echo.
echo This GRAPH selectes and consolidates the larger SMT data set created
echo in demo-1.sh and creates a tm "BUILD" set of 12 files. This
echo GRAPH's config file defines:
echo      mertset = 500
echo      evalset = 500
echo.
echo Command:  "%~d0> %BASE% build-tm"
echo.
if not "%1" == "-c" pause
cls







echo Example 12: create a tm BUILD set named "demo_tm"
echo.
echo Command:  "%~d0> %BASE% build-tm"
echo.
if exist "%graphs%\build-tm\Demonstrate building tm build set with demo nl-en corpus.conf" (
	copy /y "%graphs%\build-tm\config.ini" "%graphs%\build-tm\.config.ini.tmp" > nul
	copy /y "%graphs%\build-tm\Demonstrate building tm build set with demo nl-en corpus.conf" "%graphs%\build-tm\config.ini" > nul
	python "%cfgm%" -v build-tm
	if errorlevel 1 (
		set result=1
	) else (
		echo.
		echo Review
		echo Command:  "%~d0> %BASE% build-tm"
		echo Inputs:   "file://%rootfolder%\CORPORA.demo\ready_demo\EuroParl%20v5\Legislation\debates\tm\nl\"
		echo Outputs:  "file://%rootfolder%\BUILDS\tm\demo_tm"
		echo.
		)
	copy /y "%graphs%\build-tm\.config.ini.tmp" "%graphs%\build-tm\config.ini" > nul
	del /q "%graphs%\build-tm\.config.ini.tmp"
) else (
	echo "build-tm" demo configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 13, train a translation model with BUILD sets named "demo_tm" and "demo_lm"
if not "%1" == "-c" pause
cls

echo Example 13: train a translation model with BUILD sets named
echo             "demo_tm" and "demo_lm"
echo.
echo The training process consists of five sub-steps:
echo    1. train-lm      - trains the language model
echo    2. train-tm      - trains the phrase and reordering tables, then
echo                       binarizes the tables This takes a long time.
echo    3. train-mert    - "Minimum Error Rate Tuning" creates a translation
echo                       model consisting of phrase and reordering tables,
echo                       a language model and confiuration file with
echo                       optimal settings. This takes a long time.
echo    5. train-recaser - trains a recaser model that restores
echo                       upper/lower case to translations
echo    4. train-eval    - evaluates the "tuned" translation model



echo.
echo Command:  "%~d0> %BASE% train"
echo.
if not "%1" == "-c" pause
cls

echo Example 13: train a translation model with BUILD sets named
echo             "demo_tm" and "demo_lm"
echo.
echo Command:  "%~d0> %BASE% train"
echo.
if exist "%graphs%\train\Demonstrate complete training and tuning with demo nl-en corpus.conf" (
	echo Can not run Example 13 on MS Windows
	echo.
rem 	if not "%1" == "-s" (
rem 		copy /y "%graphs%\train\config.ini" "%graphs%\train\.config.ini.tmp" > nul
rem 		copy /y "%graphs%\train\Demonstrate complete training and tuning with demo nl-en corpus.conf" "%graphs%\train\config.ini" > nul
rem 		python "%cfgm%" -v train
rem 		if errorlevel 1 (
rem 			set result=1
rem 		) else (
rem 			echo.
rem 			echo Review
rem 			echo Command:  "%~d0> %BASE% train"
rem 			echo Input1:   "file://%rootfolder%\BUILDS\lm\demo_lm"
rem 			echo Input2:   "file://%rootfolder%\BUILDS\tm\demo_tm"
rem 			echo Output:  "file://%rootfolder%\ENGINES\evals\eval-s=nl-t=en-p=demo_tm-a=giza-g=3-l=demo_lm-T=irstlm-n=3\moses-mert.mteval-v12.pl.txt"
rem 			echo.
rem 			)
rem 		copy /y "%graphs%\train\.config.ini.tmp" "%graphs%\train\config.ini" > nul
rem 		del /q "%graphs%\train\.config.ini.tmp"
rem 		)
) else (
	echo "train" demo configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Example 14, translate sample document
if not "%1" == "-c" pause
cls

echo Example 14: translate sample document
echo.
echo This example uses the "translate" GRAPH to translate a sample
echo document using the "demo_tm" translation engine.
echo.
echo Command:  "%~d0> %BASE% translate"
echo.
if not "%1" == "-c" pause
cls

echo Example 14: translate sample document
echo.
echo Command:  "%~d0> %BASE% translate"
echo.
if exist "%graphs%\translate\Demonstrate translations using two different SMT models and a recaser model nl-en.conf" (
	echo Can not run Example 14 on MS Windows
	echo.
rem 	copy /y "%graphs%\translate\config.ini" "%graphs%\translate\.config.ini.tmp" > nul
rem 	copy /y "%graphs%\translate\Demonstrate translations using two different SMT models and a recaser model nl-en.conf" "%graphs%\translate\config.ini" > nul
rem 	python "%cfgm%" -v translate
rem 	if errorlevel 1 (
rem 		set result=1
rem 	) else (
rem 		if %result% equ 1 goto :leave
rem 		echo.
rem 		echo Review
rem 		echo Command:  "%~d0> %BASE% translate"
rem 		echo Inputs:   "file://%rootfolder%\TRANSLATIONS\in\lm\nl\nl\sample-ce.txt"
rem 		echo Outputs:  "file://%rootfolder%\TRANSLATIONS\out\tm\nl\sample-ce.txt.tmx"
rem 		echo.
rem 		)
rem 		copy /y "%graphs%\translate\.config.ini.tmp" "%graphs%\translate\config.ini" > nul
rem 		del /q "%graphs%\translate\.config.ini.tmp"
) else (
	echo "translate" demo configuration is not installed.
	echo.
	)
if not %result%==0 (
	call :leave
	exit /b %result%
	)

echo Next: Review
if not "%1" == "-c" pause
cls

echo Review:
echo.
echo Demo-2.sh examples created "BUILD" sets, trained translation
echo engines and translated an example document.
echo.
echo Example 6 cleaned a micro corpus for use as SMT training corpus
echo Example 7 created the lm BUILD set named "micro_lm"
echo Example 8 created the tm BUILD set named "micro_tm"
echo Example 9 trained, tuned, evaluated a "micro" translation model [Linux only]
echo Example 10 cleaned a demo corpus from same data with different options
echo Example 11 created the lm BUILD set named "demo_lm"
echo Example 12 created the tm BUILD set named "demo_tm"
echo Example 13 trained, tune, evaluate a "demo" translation model [Linux only]
echo Example 14 translated sample document with an engine using both models [Linux only]

echo Next: NOTES
if not "%1" == "-c" pause
cls

echo NOTE: All outputs from these examples were saved in sub-folders
echo under "%rootfolder%\BUILDS\", "%rootfolder%\ENGINES\", and
echo "%rootfolder%\TRANSLATIONS\". It is safe to delete the demo
echo sub-folders at any time.
echo.
echo NOTE 2: You may want to rerun demo-2.sh. If you first delete the
echo   output folders, you can watch the demo create the output files
echo   and review the results of each example before proceeding to
echo   the next example. If you do not delete the output, the sub-steps
echo   in "train" examples will detect the previous output and skip to
echo   the next step.
echo.

echo Next: What's next?
if not "%1" == "-c" pause
cls

echo Next Steps:
echo.
echo 1. review the user's manual "DoMY CE Users Manual.doc"
echo    from the icon on your desktop, or in your %graphs%
echo    folder on server hosts
echo 2. pick an example GRAPH that best matches your needs. Edit the
echo    config.ini file [in %graphs%] to your language pair.
echo 3. put your data files in a folder hierarchy folder under
echo    %rootfolder%\CORPORA that matches your needs.
echo 4. run the edited GRAPH configuration.
echo.

call :leave
exit /b 0

:leave
	if %deletegraphs%==1 ( rd /s /q "%graphs%" 2>nul )
	if %deleteplugins%==1 ( rd /s /q "%plugins%" 2>nul )
	goto :EOF

:: DoMY CE v2.5.330
:: Copyright  2010-2011 Precision Translation Tools Co., Ltd.

:: This program is free software: you can redistribute it and\or modify
:: it under the terms of the GNU Lesser General Public License as published by
:: the Free Software Foundation, either version 3 of the License, or
:: (at your option) any later version.

:: This program is distributed in the hope that it will be useful,
:: but WITHOUT ANY WARRANTY; without even the implied warranty of
:: MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
:: GNU Lesser General Public License for more details.

:: You should have received a copy of the GNU Lesser General Public License
:: along with this program.  If not, see http://www.gnu.org/licenses/

:: For more information, please contact Precision Translation Tools Co., Ltd.
:: at: http://www.precisiontranslationtools.com
