#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Walapa Muangjeen
#===============================================================================

#version:
#2.5.321 - added progress bar

import os
import sys
import common as cf
import logging

logger = logging.getLogger('.'.join([os.path.splitext(os.path.basename(sys.argv[0]))[0],'manager','filtergraph',__name__]))
skipclose = True

class filter(object):

	cfg = {
		'encoding': 'utf8',
		'inputfile': '',
		'outputfile': '',
		'version': '2.5.321',
		}
	encoding = 'utf8'
	inputfile = ''
	outputfile = ''
	replace = {
		u'\x00': u'%(#x00)s',
		u'\x01': u'%(#x01)s',
		u'\x02': u'%(#x02)s',
		u'\x03': u'%(#x03)s',
		u'\x04': u'%(#x04)s',
		u'\x05': u'%(#x05)s',
		u'\x06': u'%(#x06)s',
		u'\x07': u'%(#x07)s',
		u'\x08': u'%(#x08)s',
		u'\x09': u'%(#x09)s',
		u'\x0a': u'%(#x0a)s',
		u'\x0b': u'%(#x0b)s',
		u'\x0c': u'%(#x0c)s',
		u'\x0d': u'%(#x0d)s',
		u'\x0e': u'%(#x0e)s',
		u'\x0f': u'%(#x0f)s',
		u'\x10': u'%(#x10)s',
		u'\x11': u'%(#x11)s',
		u'\x12': u'%(#x12)s',
		u'\x13': u'%(#x13)s',
		u'\x14': u'%(#x14)s',
		u'\x15': u'%(#x15)s',
		u'\x16': u'%(#x16)s',
		u'\x17': u'%(#x17)s',
		u'\x18': u'%(#x18)s',
		u'\x19': u'%(#x19)s',
		u'\x1a': u'%(#x1a)s',
		u'\x1b': u'%(#x1b)s',
		u'\x1c': u'%(#x1c)s',
		u'\x1d': u'%(#x1d)s',
		u'\x1e': u'%(#x1e)s',
		u'\x1f': u'%(#x1f)s',
#		u'\x7c': u'%(#x7c)s', # |
		u'\x7f': u'%(#x7f)s',
		}
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.encoding = 'utf8' if 'utf8' in cfg['encoding'].lower().replace('-','') else cfg['encoding']
		self.inputfile = cfg['inputfile'].replace('%(rootfolder)s',self.p.rootfolder) if cfg['inputfile'] else self.inputfile
		self.outputfile = cfg['outputfile'].replace('%(rootfolder)s',self.p.rootfolder) if cfg['outputfile'] else self.outputfile
		if (self.inputfile and not self.outputfile) or (not self.inputfile and self.outputfile):
			self.errors.append([__name__,'invalid','[%s] inputfile=%s without outputfile= value'%(__name__,cfg['inputfile'])])
			logger.warn('%s\t%s',*self.errors[-1][1:])

	def run(self,k):
		global skipclose
		skipclose = not self.inputfile
		if self.inputfile: return

		self.p.cfoutput[k]['tempbuff'] = [self.__filter(line) for line in self.p.cfoutput[k]['tempbuff']]

	def flush(self,k):
		return

	def close(self):
		if skipclose: return

		import codecs
		from progress_bar import ProgressBar

		if not os.path.exists(self.inputfile):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.inputfile)])
			logger.error('%s\t%s',*self.errors[-1][1:])
			return

		# make output folder
		try:
			os.makedirs(os.path.dirname(self.outputfile))
		except OSError,e:
			if not e.errno == 17:
				logger.exception('%s\t%s, %s, %s',*['failed',e.errno,e.strerror,e.filename,])
				raise OSError(e)

		# open input and output files
		out = self.outputfile
		if out == self.inputfile:
			import tempfile
			fd,out = tempfile.mkstemp(suffix='.tmp', prefix='~', dir=self.p.tempdir)
			os.close(fd)
		try:
			o = codecs.open(out,'w',self.encoding)
			i = codecs.open(self.inputfile,'r',self.encoding)
			ttl_lines = cf.file_length(self.inputfile)
		except:
			raise RuntimeError('Failed to open [%s] input/output files'%(__name__))

		progress = ProgressBar()
		progress.reset(0,ttl_lines,72,mode='fixed',char='#')
		sys.stderr.write('[%s] %s\n'%(__name__,self.outputfile))

		try:
			# loop writes output line-by-line
			for line in i:
				o.write('%s\n'%(self.__filter(line.rstrip('\r\n'))))
				progress.increment_amount()
				sys.stderr.write(progress.bar)
				sys.stderr.flush()
			sys.stderr.write('\n')
			progress.update_amount(ttl_lines)
			sys.stderr.write(progress.bar)
			sys.stderr.write('\n')
			sys.stderr.flush()
			# close input and output files
			i.close()
			o.close()

			if not out == self.outputfile:
				import shutil
				shutil.move(out,self.outputfile)

		except KeyboardInterrupt:
			os.unlink(out)
			raise KeyboardInterrupt()

		if not os.path.exists(self.outputfile):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.outputfile)])
			logger.error('%s\t%s',*self.errors[-1][1:])

	def __filter(self,text):
		'''replace problematic control characters'''
		for i, j in self.replace.items():
			text = text.replace(i, j)
		return text

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filter\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''DoMY™ CE v2.5
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')

'''
DEC 	OCT 	HEX 	BIN 	Symbol 	HTML Number 	HTML Name 	Description
0	000	00	00000000	NUL	&#000;	Null char
1	001	01	00000001	SOH	&#001;	Start of Heading
2	002	02	00000010	STX	&#002;	Start of Text
3	003	03	00000011	ETX	&#003;	End of Text
4	004	04	00000100	EOT	&#004;	End of Transmission
5	005	05	00000101	ENQ	&#005;	Enquiry
6	006	06	00000110	ACK	&#006;	Acknowledgment
7	007	07	00000111	BEL	&#007;	Bell
8	010	08	00001000	BS	&#008;	Back Space
9	011	09	00001001	HT	&#009;	Horizontal Tab
10	012	0A	00001010	LF	&#010;	Line Feed
11	013	0B	00001011	VT	&#011;	Vertical Tab
12	014	0C	00001100	FF	&#012;	Form Feed
13	015	0D	00001101	CR	&#013;	Carriage Return
14	016	0E	00001110	SO	&#014;	Shift Out / X-On
15	017	0F	00001111	SI	&#015;	Shift In / X-Off
16	020	10	00010000	DLE	&#016;	Data Line Escape
17	021	11	00010001	DC1	&#017;	Device Control 1 (oft. XON)
18	022	12	00010010	DC2	&#018;	Device Control 2
19	023	13	00010011	DC3	&#019;	Device Control 3 (oft. XOFF)
20	024	14	00010100	DC4	&#020;	Device Control 4
21	025	15	00010101	NAK	&#021;	Negative Acknowledgement
22	026	16	00010110	SYN	&#022;	Synchronous Idle
23	027	17	00010111	ETB	&#023;	End of Transmit Block
24	030	18	00011000	CAN	&#024;	Cancel
25	031	19	00011001	EM	&#025;	End of Medium
26	032	1A	00011010	SUB	&#026;	Substitute
27	033	1B	00011011	ESC	&#027;	Escape
28	034	1C	00011100	FS	&#028;	File Separator
29	035	1D	00011101	GS	&#029;	Group Separator
30	036	1E	00011110	RS	&#030;	Record Separator
31	037	1F	00011111	US	&#031;	Unit Separator
124		7C	???11111	| 	&#124;	vertical bar
127		7F	11111111	DEL	&#127;	delete (rubout)
'''
