#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Walapa Muangjeen
#===============================================================================

#version:
#2.5.321 - added progress bar

import os
import sys
import common as cf
import logging

logger = logging.getLogger('.'.join([os.path.splitext(os.path.basename(sys.argv[0]))[0],'manager','filtergraph',__name__]))
skipclose = True

class filter(object):

	cfg = {
		'encoding': 'utf8',
		'inputfile': '',
		'outputfile': '',
		'version': '2.5.321',
		}
	encoding = 'utf8'
	inputfile = ''
	outputfile = ''
	replace = {
		# new escapes
		u'%(#x00)s': u'\x00',
		u'%(#x01)s': u'\x01',
		u'%(#x02)s': u'\x02',
		u'%(#x03)s': u'\x03',
		u'%(#x04)s': u'\x04',
		u'%(#x05)s': u'\x05',
		u'%(#x06)s': u'\x06',
		u'%(#x07)s': u'\x07',
		u'%(#x08)s': u'\x08',
		u'%(#x09)s': u'\x09',
		u'%(#x0a)s': u'\x10',
		u'%(#x0b)s': u'\x0b',
		u'%(#x0c)s': u'\x0c',
		u'%(#x0d)s': u'\x0d',
		u'%(#x0e)s': u'\x0e',
		u'%(#x0f)s': u'\x0f',
		u'%(#x10)s': u'\x10',
		u'%(#x11)s': u'\x11',
		u'%(#x12)s': u'\x12',
		u'%(#x13)s': u'\x13',
		u'%(#x14)s': u'\x14',
		u'%(#x15)s': u'\x15',
		u'%(#x16)s': u'\x16',
		u'%(#x17)s': u'\x17',
		u'%(#x18)s': u'\x18',
		u'%(#x19)s': u'\x19',
		u'%(#x1a)s': u'\x1a',
		u'%(#x1b)s': u'\x1b',
		u'%(#x1c)s': u'\x1c',
		u'%(#x1d)s': u'\x1d',
		u'%(#x1e)s': u'\x1e',
		u'%(#x1f)s': u'\x1f',
		u'%(#x7c)s': u'\x7c', # |
		u'%(#x7f)s': u'\x7f',
		# old escapes
		u'&nul;': u'\x00',
		u'&soh;': u'\x01',
		u'&stx;': u'\x02',
		u'&etx;': u'\x03',
		u'&eot;': u'\x04',
		u'&enq;': u'\x05',
		u'&ack;': u'\x06',
		u'&bel;': u'\x07',
		u'&bs;' : u'\x08',
		u'&ht;' : u'\x09',
		u'&lf;' : u'\x0a',
		u'&vt;' : u'\x0b',
		u'&ff;' : u'\x0c',
		u'&cr;' : u'\x0d',
		u'&so;' : u'\x0e',
		u'&si;' : u'\x0f',
		u'&dle;': u'\x10',
		u'&dc1;': u'\x11',
		u'&dc2;': u'\x12',
		u'&dc3;': u'\x13',
		u'&dc4;': u'\x14',
		u'&nak;': u'\x15',
		u'&syn;': u'\x16',
		u'&etb;': u'\x17',
		u'&can;': u'\x18',
		u'&em;' : u'\x19',
		u'&sub;': u'\x1a',
		u'&esc;': u'\x1b',
		u'&fs;' : u'\x1c',
		u'&gs;' : u'\x1d',
		u'&rs;' : u'\x1e',
		u'&us;' : u'\x1f',
		u'&vb;' : u'\x7c',
		u'&del;': u'\x7f',
		}
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.encoding = 'utf8' if 'utf8' in cfg['encoding'].lower().replace('-','') else cfg['encoding']
		self.inputfile = cfg['inputfile'].replace('%(rootfolder)s',self.p.rootfolder) if cfg['inputfile'] else self.inputfile
		self.outputfile = cfg['outputfile'].replace('%(rootfolder)s',self.p.rootfolder) if cfg['outputfile'] else self.outputfile
		if (self.inputfile and not self.outputfile) or (not self.inputfile and self.outputfile):
			self.errors.append([__name__,'invalid','[%s] inputfile=%s without outputfile= value'%(__name__,cfg['inputfile'])])
			logger.warn('%s\t%s',*self.errors[-1][1:])

	def run(self,k):
		global skipclose
		skipclose = not self.inputfile
		if self.inputfile: return

		self.p.cfoutput[k]['tempbuff'] = [self.__filter(line) for line in self.p.cfoutput[k]['tempbuff']]

	def flush(self,k):
		return

	def close(self):
		if skipclose: return

		import codecs
		from progress_bar import ProgressBar

		if not os.path.exists(self.inputfile):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.inputfile)])
			logger.error('%s\t%s',*self.errors[-1][1:])
			return

		# make output folder
		try:
			os.makedirs(os.path.dirname(self.outputfile))
		except OSError,e:
			if not e.errno == 17:
				logger.exception('%s\t%s, %s, %s',*['failed',e.errno,e.strerror,e.filename,])
				raise OSError(e)

		# open input and output files
		out = self.outputfile
		if out == self.inputfile:
			import tempfile
			fd,out = tempfile.mkstemp(suffix='.tmp', prefix='~', dir=self.p.tempdir)
			os.close(fd)
		try:
			o = codecs.open(out,'w',self.encoding)
			i = codecs.open(self.inputfile,'r',self.encoding)
			ttl_lines = cf.file_length(self.inputfile)
		except:
			raise RuntimeError('Failed to open [%s] input/output files'%(__name__))

		progress = ProgressBar()
		progress.reset(0,ttl_lines,72,mode='fixed',char='#')
		sys.stderr.write('[%s] %s\n'%(__name__,self.outputfile))

		try:
			# loop writes output line-by-line
			for line in i:
				o.write('%s\n'%(self.__filter(line.rstrip('\r\n'))))
				progress.increment_amount()
				sys.stderr.write(progress.bar)
				sys.stderr.flush()
			sys.stderr.write('\n')
			progress.update_amount(ttl_lines)
			sys.stderr.write(progress.bar)
			sys.stderr.write('\n')
			sys.stderr.flush()
			# close input and output files
			i.close()
			o.close()

			if not out == self.outputfile:
				import shutil
				shutil.move(out,self.outputfile)

		except KeyboardInterrupt:
			os.unlink(out)
			raise KeyboardInterrupt()

		if not os.path.exists(self.outputfile):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.outputfile)])
			logger.error('%s\t%s',*self.errors[-1][1:])

	def __filter(self,text):
		'''restore problematic control characters'''
		for i, j in self.replace.items():
			text = text.replace(i, j)
		return text

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filter\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''DoMY™ CE v2.5
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
